

/**
 ******************************************************************************
 *
 * @file        
 * @brief        
 *
 * @par         Project
 *              MG32F02N128
 * @version     V1.00
 * @date        2024/08/28
 * @author      Megawin Software Center
 * @copyright   Copyright (c) 2017 MegaWin Technology Co., Ltd.
 *              All rights reserved.
 *
 ******************************************************************************* 
 * @par Disclaimer
 * The Demo software is provided "AS IS" without any warranty, either
 * expressed or implied, including, but not limited to, the implied warranties
 * of merchantability and fitness for a particular purpose. The author will
 * not be liable for any special, incidental, consequential or indirect
 * damages due to loss of data or any other reason.
 * These statements agree with the world wide and local dictated laws about
 * authorship and violence against these laws.
 *******************************************************************************
 *******************************************************************************
 */

#ifndef _CALENDAR_H
#define _CALENDAR_H


/* Includes ------------------------------------------------------------------*/
#include "MG32.h"


/* Menu ----------------------------------------------------------------------*/
/* Define --------------------------------------------------------------------*/

/* Typedef -------------------------------------------------------------------*/
typedef struct __attribute__((packed))
{
    __IO uint32_t  Year;
    __IO uint16_t  mSecond;
    __IO uint8_t   Month;
    __IO uint8_t   Day;
    __IO uint8_t   Hour;
    __IO uint8_t   Minute;
    __IO uint8_t   Second;
}Calendar_TypeDef;


/* Macro ---------------------------------------------------------------------*/
/* variables -----------------------------------------------------------------*/
extern Calendar_TypeDef  Calendar_CTR;

/* Functions -----------------------------------------------------------------*/

void Calendar_Init(void);
void Calendar_Handler(void);


#endif





